Attribute VB_Name = "Mod_InfoBulle"
Option Explicit
'
'======================================================
'
'  O      O   *********************************\
'   \____/      Info-bulle                      \
'  (/-  -\)   ***********************************\
'  |  \/  |     Conception and realization        \
'  |  __  |     CodeSource by Nocturne             \
'   \____/      January 2006                        \
'  __|  |__                                          \
' /        \  ****************************************\
'
'======================================================
'
'*****************************************
'*****Module de traitement info-bulle*****
'*****************************************
'
'*****Dclaration des variables concernant l'info-bulle*****
'Dclaration des dcalages des lments  l'intrieur de InfoBulle_picture
'Variable horizontale, verticale
'Les variables de dcalages du texte fonctionnent avec les 4 types d'info-bulle
Public DecalHorz_Txt_HG As Long 'en %
Public DecalVert_Txt_HG As Long 'en %
Public DecalHorz_Txt_BG As Long 'en %
Public DecalVert_Txt_BG As Long 'en %
Public DecalHorz_Txt_HD As Long 'en %
Public DecalVert_Txt_HD As Long 'en %
Public DecalHorz_Txt_BD As Long 'en %
Public DecalVert_Txt_BD As Long 'en %
Public DecalHorz_Pan As Long 'en %
Public DecalVert_Pan As Long 'en %
Public DecalHorz_Cls As Long 'en %
Public DecalVert_Cls As Long 'en %

'Variable d'augmentation de surface, InfoBulle_Picture
Public AjustSurface_Lg As Long 'en %
Public AjustSurface_Ht As Long 'en %

'Changer une couleur de l'info-bulle par une autre
Public Infobulle_ChangeColor As Boolean 'Si True, active le changement de couleur
Public Infobulle_OldColor As Long 'Indiquer la couleur a changer
Public Infobulle_NewColor As Long 'Select nouvelle couleur

'Hauteur, largeur texte info-bulle
Public Ht_Txt As Long
Public Lg_Txt As Long
'Hauteur, largeur du panneau
Public Ht_Panneau As Long
Public Lg_Panneau As Long
'Hauteur, largeur case fermeture
Public Ht_Close As Long
Public Lg_Close As Long

'Index du panneau  afficher
Public PanneauIndex As Long
'Affichage case fermeture
Public Affiche_Close As Boolean

'Mmoire de slection du type info-bulle
Public Mem_InfobulleType As Long
'Mmoire position du bec info-bulle
Public Mem_PosBec As String
'Mmorisation du nom de l'objet qui dclenche l'info-bulle
Public Mem_ObjetDeclencheur As String
'Info-Bulle active
Public Active_InfoBulle As Boolean

'Dclaration des variables de dcalage par rapport  la souris
'Les 4 coins info-bulle, HG, BG, HD, et BD
'Deux dcalages par coins, horizontale et verticale
'Zone en haut  gauche
Public HG_Ajust_Y As Long 'Ajustage en hauteur en %
Public HG_Ajust_X As Long 'Ajustage en largeur en %
'Zone en bas  gauche
Public BG_Ajust_Y As Long 'Ajustage en hauteur en %
Public BG_Ajust_X As Long 'Ajustage en largeur en %
'Zone en haut  droite
Public HD_Ajust_Y As Long 'Ajustage en hauteur en %
Public HD_Ajust_X As Long 'Ajustage en largeur en %
'Zone en bas  droite
Public BD_Ajust_Y As Long 'Ajustage en hauteur en %
Public BD_Ajust_X As Long 'Ajustage en largeur en %
'Indique la couleur qui doit etre transparente
Public TransColor_InfoBulle As Long

'*****Pour info*****
'*****Constante*****Valeur*******Description*****************************
'vbBlack            &H0          Noir
'vbRed              &HFF         Rouge
'vbGreen            &HFF00       Vert
'vbYellow           &HFFFF       Jaune
'vbBlue             &HFF0000     Bleu
'vbMagenta          &HFF00FF     Magenta
'vbCyan             &HFFFF00     Cyan
'vbWhite            &HFFFFFF     Blanc
'vbGrayText         &H80000011   Texte gris (dsactiv)
'vbButtonText       &H80000012   Couleur du texte des boutons de commande
'vbInfoText         &H80000017   Couleur du texte des info-bulles
'vbInfoBackground   &H80000018   Couleur d'arrire-plan des info-bulles
'*************************************************************************

'*****Traitement de l'image*****
Private Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Private Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

'Private Type BITMAP '24 bytes
'  bmType As Long
'  bmWidth As Long
'  bmHeight As Long
'  bmWidthBytes As Long
'  bmPlanes As Integer
'  bmBitsPixel As Integer
'  bmBits As Long
'End Type

Private Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors As RGBQUAD
End Type

'Private bi24BitInfo As BITMAPINFO
'Private bytes_per_scanLine As Integer
'Private pad_per_scanLine As Integer
'Private Bits_Per_Pixels As Long 'Nombre de couleurs

Private Const DIB_RGB_COLORS = 0 'Table de couleurs en RGB
Private Const BI_RGB = 0&

Private Declare Sub OleTranslateColor Lib "oleaut32.dll" (ByVal clr As Long, _
  ByVal hpal As Long, ByRef lpcolorref As Long)

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, _
  ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
  ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

'Private Declare Function StretchBlt Lib "gdi32" ( _
'  ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, _
'  ByVal nWidth As Long, ByVal nHeight As Long, _
'  ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, _
'  ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, _
  ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, _
  lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Private Declare Function SetDIBits Lib "gdi32" (ByVal hDC As Long, _
  ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, _
  lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

'Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" ( _
'  ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
 
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long

Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, _
  pBitmapInfo As BITMAPINFO, ByVal un As Long, ByVal lplpVoid As Long, _
  ByVal handle As Long, ByVal dw As Long) As Long

Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
'Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long

'******Pour la Sub CreateMaskBmp d'EBArtSoft*****
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, _
  ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, _
  ByVal lpBits As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, _
  ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private MaskColor As Long
'************************************************

Public Function Remplace_Couleur(PctBox_Image As Object, ByVal Couleur_Select As Long, ByVal Couleur_Final As Long) As Long
Dim Mem_AutoRedraw As Boolean
Dim Mem_ScaleMode As ScaleModeConstants

On Error Resume Next
'Mmorisation de l'unit de mesure (vbPixel, vbTwips, ...)
Mem_ScaleMode = PctBox_Image.ScaleMode
'Mmorisation de la mthode graphique
Mem_AutoRedraw = PctBox_Image.AutoRedraw

PctBox_Image.AutoRedraw = True
PctBox_Image.ScaleMode = vbPixels 'Mesure en pixels - chelle

If Form1.Option3(0).Value = True Then 'Procdure Change_Couleur pour comparer
  'Appel la procdure qui va remplacer la couleur par une autre
  Call Change_Couleur(PctBox_Image, Couleur_Select, Couleur_Final)
  PctBox_Image.ScaleMode = Mem_ScaleMode
  ''PctBox_Image.Refresh 'Actualise notre image
  PctBox_Image.AutoRedraw = Mem_AutoRedraw
Else 'Sub CreateMaskBmp d'EBArtSoft
  'Initialise
  MaskColor = Couleur_Select 'Couleur qui doit tre transparente
  Form1.Picture1.Picture = LoadPicture("")
  Form1.Picture1.AutoRedraw = PctBox_Image.AutoRedraw
  Form1.Picture1.ScaleMode = PctBox_Image.ScaleMode
  Form1.Picture1.BackColor = Couleur_Final 'Nouvelle couleur
  Form1.Picture1.Width = PctBox_Image.Width
  Form1.Picture1.Height = PctBox_Image.Height
  'Form1.Picture1.Picture.Width = PctBox_Image.Picture.Width
  'Form1.Picture1.Picture.Height = PctBox_Image.Picture.Height

  Call CreateMaskBmp(PctBox_Image, Form1.Picture1, Form1.Picture1)

  PctBox_Image.ScaleMode = Mem_ScaleMode
  ''PctBox_Image.Refresh 'Actualise notre image
  PctBox_Image.AutoRedraw = Mem_AutoRedraw

  PctBox_Image.Picture = Form1.Picture1.Picture 'Transfert image finale
End If
'En conclusion la procdure CreateMaskBmp d'EBArtSoft est bien plus rapide
End Function
 
Private Function Change_Couleur(ImgSource As Object, ByVal Select_Color As Long, ByVal Final_Color As Long) As Long
'Procdure de modification d'une couleur par une autre
Dim Img_hDC As Long
Dim Img_Width As Long: Dim Img_Height As Long
Dim Bi_Width As Long: Dim Bi_Height As Long
Dim bi24BitInfo As BITMAPINFO
Dim ImgBits() As Byte
Dim Tmp_ImghDC As Long: Dim hTmp_Bitmap As Long
Dim Final_RealColor As Long
Dim RColor As Byte: Dim GColor As Byte: Dim BColor As Byte
Dim X As Long, Y As Long

On Error Resume Next

Img_hDC = ImgSource.hDC 'Rcupere le handle de notre image
Img_Width = ImgSource.ScaleWidth
Img_Height = ImgSource.ScaleHeight - 1
Bi_Width = (ImgSource.ScaleWidth \ 4) * 4 + 4
Bi_Height = ImgSource.ScaleHeight

'Format de l'image
With bi24BitInfo.bmiHeader
  .biBitCount = 24
  .biCompression = BI_RGB
  .biPlanes = 1
  .biSize = Len(bi24BitInfo.bmiHeader)
  .biWidth = Bi_Width
  .biHeight = Bi_Height + 1
End With

'Prparation d'un tableau de bits pour la rcupration de l'image
ReDim ImgBits(0 To bi24BitInfo.bmiHeader.biWidth * 3 - 1, 0 To bi24BitInfo.bmiHeader.biHeight - 1)

'Cration objet image temporaire
'On cre un context mmoire compatible - Device Context (DC) pour accder  notre image temporaire
Tmp_ImghDC = CreateCompatibleDC(Img_hDC)
'On cre un DIB, Zone mmoire qui va accueillir notre image
hTmp_Bitmap = CreateDIBSection(Tmp_ImghDC, bi24BitInfo, DIB_RGB_COLORS, ByVal 0&, ByVal 0&, ByVal 0&)
'hTmp_Bitmap = CreateCompatibleBitmap(Img_hDC, bi24BitInfo.bmiHeader.biWidth, bi24BitInfo.bmiHeader.biHeight)
'On attache le Dib au DC
'DeleteObject (SelectObject(Tmp_ImghDC, hTmp_Bitmap))

'Dim Ancien_DIB As Long
'Ancien_DIB = SelectObject(Tmp_ImghDC, hTmp_Bitmap)
Call SelectObject(Tmp_ImghDC, hTmp_Bitmap)

'On copie le rsultat dans le DC et on rcupre les data avec GetDiBits
Call BitBlt(Tmp_ImghDC, 0, 0, bi24BitInfo.bmiHeader.biWidth, bi24BitInfo.bmiHeader.biHeight, Img_hDC, 0, 0, vbSrcCopy)
'Rcupration de l'image source dans un tableau de bits  2 dimensions
Call GetDIBits(Tmp_ImghDC, hTmp_Bitmap, 0, bi24BitInfo.bmiHeader.biHeight, ImgBits(0, 0), bi24BitInfo, DIB_RGB_COLORS)

'CLEAN - Nettoyage
'Il semblerait que deux nettoyages est mieux gr par Win98, pourquoi??
'Call DeleteObject(hTmp_Bitmap)
'Call DeleteDC(Tmp_ImghDC)
'Call DeleteObject(hTmp_Bitmap)
'Call DeleteDC(Tmp_ImghDC)

'Conversion d'une couleur OLE_COLOR en RGB
Final_RealColor = Final_Color
OleTranslateColor Final_RealColor, 0&, Final_RealColor
'Resultat conversion RGB
RColor = Final_RealColor And &HFF&
GColor = (Final_RealColor And &HFF00&) / 2 ^ 8
BColor = (Final_RealColor And &HFF0000) / 2 ^ 16

'On parcours notre tableau, on slectionne la couleur et on la modifie
Y = 0
Dim Rang_X As Long: Rang_X = 0
Do While Y < Img_Height + 1
  X = 0
  Do While X < Img_Width
    If RGB(ImgBits(X * 3 + 2, Img_Height - Y + 1), ImgBits(X * 3 + 1, Img_Height - Y + 1), _
           ImgBits(X * 3, Img_Height - Y + 1)) = Select_Color Then 'Selection couleur
      'Couleur de remplacement
      ImgBits(X * 3 + 2, Img_Height - Y + 1) = RColor
      ImgBits(X * 3 + 1, Img_Height - Y + 1) = GColor
      ImgBits(X * 3, Img_Height - Y + 1) = BColor
    End If
    X = X + 1
    'If RGB(ImgBits(Rang_X + 2, Img_Height - Y + 1), ImgBits(Rang_X + 1, Img_Height - Y + 1), _
    '       ImgBits(Rang_X, Img_Height - Y + 1)) = Select_Color Then 'Selection couleur
    '  'Couleur de remplacement
    '  ImgBits(Rang_X + 2, Img_Height - Y + 1) = RColor
    '  ImgBits(Rang_X + 1, Img_Height - Y + 1) = GColor
    '  ImgBits(Rang_X, Img_Height - Y + 1) = BColor
    'End If
    'Rang_X = Rang_X + 3
    'X = X + 1
  Loop
  Y = Y + 1
Loop
'Tmp_ImghDC = CreateCompatibleDC(Img_hDC)
'hTmp_Bitmap = CreateDIBSection(Tmp_ImghDC, bi24BitInfo, DIB_RGB_COLORS, ByVal 0&, ByVal 0&, ByVal 0&)
'DeleteObject (SelectObject(Tmp_ImghDC, hTmp_Bitmap))

'On rcupre l'image modifier du tableau de bits et on la copie dans notre image temporaire
Call SetDIBits(Tmp_ImghDC, hTmp_Bitmap, 0, bi24BitInfo.bmiHeader.biHeight, ImgBits(0, 0), bi24BitInfo, DIB_RGB_COLORS)

'On copie l'image temporaire dans notre image source
Call BitBlt(ImgSource.hDC, 0, 0, Bi_Width, Bi_Height, Tmp_ImghDC, 0, 0, vbSrcCopy)
'On copie l'image temporaire dans notre image source et on la stretch (s'adapte  la dimension du pictureBox)
'Call StretchBlt(ImgSource.hDC, 0, 0, Bi_Width, Bi_Height, _
'Tmp_ImghDC, 0, 0, Bi_Width, Bi_Height, vbSrcCopy)

'SelectObject Tmp_ImghDC, Ancien_DIB
'Call DeleteObject(hTmp_Bitmap)
'Call DeleteDC(Tmp_ImghDC)

'CLEAN - Nettoyage
Call DeleteObject(hTmp_Bitmap)
Call DeleteDC(Tmp_ImghDC)
Call DeleteObject(hTmp_Bitmap)
Call DeleteDC(Tmp_ImghDC)
'Libre le device context
'Call ReleaseDC(Tmp_ImghDC, Img_hDC)
'Call ReleaseDC(Tmp_ImghDC, Img_hDC)

'Libre la mmoire utilise
Erase ImgBits

End Function

Private Sub CreateMaskBmp(ImxA As PictureBox, ImxB As PictureBox, ImxC As PictureBox)
'Procdure dvelopp par : EBArtSoft
'Code source d'origine : http://www.vbfrance.com/article.aspx?ID=8991
'Titre : COMBINER 2 IMAGES AVEC 1 COULEUR CLEF
' O    O    O
'  \__/ \__/
'  /=||=||=\   oouuuunnnnnnnnmmmmmmmmmmmmmm\
' // ||_||               Key Blender        \
' \\ /\ #\     oouuuunnnnnnnnmmmmmmmmmmmmmmmm\
' /=(  \  )==>       Coded by EBArtSoft@      \
'//  \O_\/            Copyright(C) 2003        \
'\\  || ||         mailto:EBArtSoft@xxx.xxx     \
' \==||=||==/  oouuuunnnnnnnnmmmmmmmmmmmmmmmmmmmm\
' ===========
'==== E.B ====

    'active la gestion d'erreur
    On Error GoTo Xe
    'definition des variables locales
    Dim hColor As Long
    '--------------- Handle de DC
    Dim hDC1 As Long
    Dim hDC2 As Long
    Dim hDC3 As Long
    Dim hDC4 As Long
    '--------------- Handle de Bitmap
    Dim Hdl1 As Long
    Dim Hdl2 As Long
    Dim Hdl3 As Long
    Dim Hdl4 As Long
    '--------------- Handle de Bitmap (Old)
    Dim Obj1 As Long
    Dim Obj2 As Long
    Dim Obj3 As Long
    Dim Obj4 As Long
    '--------------- Taille de l'image
    Dim ImxX As Long
    Dim ImxY As Long
    'Recupere la taille de l'image (approximation)
    
    ImxX = (ImxA.Picture.Width / 27) '27
    ImxY = (ImxA.Picture.Height / 23) '27
    'l'image de destination prend la taille de l'image B (Decor)
    Set ImxC.Picture = ImxB.Picture
    'Cre les Contextes de peripheriques
    hDC1 = CreateCompatibleDC(ImxA.hDC)
    hDC2 = CreateCompatibleDC(ImxA.hDC)
    hDC3 = CreateCompatibleDC(ImxA.hDC)
    hDC4 = CreateCompatibleDC(ImxA.hDC)
    'cre les bitmaps ncessaires
    Hdl2 = CreateBitmap(ImxX, ImxY, 1, 1, 0)
    Hdl3 = CreateBitmap(ImxX, ImxY, 1, 1, 0)
    Hdl4 = CreateCompatibleBitmap(ImxA.hDC, ImxX, ImxY)
    Hdl1 = CreateCompatibleBitmap(ImxA.hDC, ImxX, ImxY)
    'lie les DC et les bitmaps
    Obj1 = SelectObject(hDC1, Hdl1)
    Obj2 = SelectObject(hDC2, Hdl2)
    Obj3 = SelectObject(hDC3, Hdl3)
    Obj4 = SelectObject(hDC4, Hdl4)
    'stock l'image intact
    BitBlt hDC1, 0, 0, ImxX, ImxY, ImxA.hDC, 0, 0, vbSrcCopy
    'defini la couleur de fond
    hColor = SetBkColor(hDC1, MaskColor)
    'cre le masque Noir et Blanc
    BitBlt hDC2, 0, 0, ImxX, ImxY, hDC1, 0, 0, vbSrcCopy
    'restore la couleur d'origine
    SetBkColor hDC1, hColor
    'fonction de transfere de masque pour plus de comprehension
    'affiche les images une par une dans un DC .... ;-D
    BitBlt hDC3, 0, 0, ImxX, ImxY, hDC2, 0, 0, vbNotSrcCopy
    BitBlt hDC4, 0, 0, ImxX, ImxY, hDC2, 0, 0, vbSrcCopy
    BitBlt hDC4, 0, 0, ImxX, ImxY, ImxC.hDC, 0, 0, vbSrcCopy
    BitBlt hDC4, 0, 0, ImxX, ImxY, hDC2, 0, 0, vbSrcAnd
    BitBlt hDC1, 0, 0, ImxX, ImxY, hDC3, 0, 0, vbSrcAnd
    BitBlt hDC4, 0, 0, ImxX, ImxY, hDC1, 0, 0, vbSrcPaint
    'dessine le resultat sur l'mage de destination
    BitBlt ImxC.hDC, 0, 0, ImxX, ImxY, hDC4, 0, 0, vbSrcCopy
    'restore les bitmaps dans les DC
    SelectObject hDC1, Obj1
    SelectObject hDC2, Obj2
    SelectObject hDC3, Obj3
    SelectObject hDC4, Obj4
    'detruit les bitmaps
    DeleteObject Hdl1
    DeleteObject Hdl2
    DeleteObject Hdl3
    DeleteObject Hdl4
    'libere les DC
    DeleteDC hDC1
    DeleteDC hDC2
    DeleteDC hDC3
    DeleteDC hDC4
    'fixe l'image de destination
    Set ImxC.Picture = ImxC.Image
    'quitte la fonction
Xi: Exit Sub
    'affiche le message d'erreur
Xe: MsgBox Err.Description, vbCritical
    'continue l'execution
    Resume Xi
End Sub

Public Sub Init_InfoBulle(ObjetTxt As Object, EspionLg As Object, EspionHt As Object, Txt_InfoBulle As String, Txt_Largeur As Long)
'Cette procdure permet de rcupr la largeur et la hauteur du texte,
'on les gardes en mmoires avec les 2 espions LabelEspion_Lg, LabelEspion_Ht

'******LES PROPRIETES A NE PAS MODIFIER - AJUSTAGE/CALIBRAGE*******
'Rglage automatique quelque soit la police utilise
'******LabelEspion_Lg******Mesure en largeur******
EspionLg.FontName = ObjetTxt.FontName
EspionLg.Font = ObjetTxt.Font
EspionLg.FontBold = ObjetTxt.FontBold
EspionLg.FontItalic = ObjetTxt.FontItalic
EspionLg.FontSize = ObjetTxt.FontSize
EspionLg.FontStrikethru = ObjetTxt.FontStrikethru
EspionLg.FontUnderline = ObjetTxt.FontUnderline
EspionLg.Caption = ""
EspionLg.AutoSize = True
EspionLg.Visible = False
'******LabelEspion_Ht******Mesure en hauteur******
EspionHt.FontName = ObjetTxt.FontName
EspionHt.Font = ObjetTxt.Font
EspionHt.FontBold = ObjetTxt.FontBold
EspionHt.FontItalic = ObjetTxt.FontItalic
EspionHt.FontSize = ObjetTxt.FontSize
EspionHt.FontStrikethru = ObjetTxt.FontStrikethru
EspionHt.FontUnderline = ObjetTxt.FontUnderline
EspionHt.Caption = ""
EspionHt.AutoSize = True
EspionHt.Visible = False
'******************************************************************

Dim Nombre_Car As Integer
Dim Compt_Ligne As Integer
Dim Premier_Car As Integer
Dim Compt As Integer

On Error Resume Next

Nombre_Car = 1
Compt_Ligne = 1 'Une ligne mini
Premier_Car = 1

If Len(Txt_InfoBulle) > 0 Then
  'Remplissage du EspionLg.Caption par rapport  Txt_Largeur
  'et on compte le nombre de lignes
  Do Until Nombre_Car > Len(Txt_InfoBulle)
    If Asc(Mid$(Txt_InfoBulle, Nombre_Car, 1)) <> 10 And Asc(Mid$(Txt_InfoBulle, Nombre_Car, 1)) <> 13 Then 'Test du saut de ligne 10 et du Enter 13
      If Len(EspionLg.Caption) < Txt_Largeur Then  'Largeur max du txt info-bulle
        EspionLg.Caption = EspionLg.Caption & Mid$(Txt_InfoBulle, Nombre_Car, 1)
      End If
    Else 'Nombre de saut de ligne ou retour chariot
      If Premier_Car = Nombre_Car Then
        'C'est juste un saut de ligne qui va tre inclu
      Else
        If Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) > Txt_Largeur Then
          'Plusieurs lignes
          If (Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) Mod Txt_Largeur) = 0 Then
            'On enlve -1 pour correction, une ligne
            Compt_Ligne = Compt_Ligne + (Fix(Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) / Txt_Largeur) - 1)
          Else
            Compt_Ligne = Compt_Ligne + Fix(Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) / Txt_Largeur)
          End If
        Else
          'Une seul ligne qui va tre inclus
        End If
      End If
      If Asc(Mid$(Txt_InfoBulle, Nombre_Car, 1)) = 10 Then 'Saut de ligne
        If Asc(Mid$(Txt_InfoBulle, Nombre_Car + 1, 1)) = 13 Then 'Retour chariot
          '10 + 13
          Nombre_Car = Nombre_Car + 1
        End If
        Compt_Ligne = Compt_Ligne + 1
      Else
        If Asc(Mid$(Txt_InfoBulle, Nombre_Car, 1)) = 13 Then
          If Asc(Mid$(Txt_InfoBulle, Nombre_Car + 1, 1)) = 10 Then
            '13 + 10
            Nombre_Car = Nombre_Car + 1
          End If
          Compt_Ligne = Compt_Ligne + 1
        Else
          'Aucun saut de ligne, aucun retour chariot, cette possibilit est thoriquement impossible
        End If
      End If
      Premier_Car = Nombre_Car + 1
    End If
    Nombre_Car = Nombre_Car + 1
  Loop
  'On a maintenant la largeur avec LabelEspion_Lg
  'Lecture pour la fin de chane
  If Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) > Txt_Largeur Then
    'Plusieurs lignes
    If (Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) Mod Txt_Largeur) = 0 Then
      Compt_Ligne = Compt_Ligne + (Fix(Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) / Txt_Largeur) - 1)
    Else
      Compt_Ligne = Compt_Ligne + Fix(Len(Mid$(Txt_InfoBulle, Premier_Car, (Nombre_Car - Premier_Car))) / Txt_Largeur)
    End If
  Else 'Une seul ligne
    'Dja inclu
  End If
End If

'On connat le nombre de lignes total
'Remplissage du EspionHt.Caption par rapport au nombre de lignes
Compt = 1
Do Until Compt > Compt_Ligne
  If EspionHt = "" Then
    EspionHt = "E"
  Else
    EspionHt = EspionHt & Chr$(10) & Chr$(13) & "e"
  End If
  Compt = Compt + 1
Loop

'On peut maintenant dfinir la largeur pour contenir notre texte
ObjetTxt.Width = EspionLg.Width
ObjetTxt.Caption = Txt_InfoBulle
'Rcupration des dimensions hauteur/largeur du texte
Ht_Txt = 0: Lg_Txt = 0
Ht_Txt = EspionHt.Height
Lg_Txt = ObjetTxt.Width
End Sub

Public Sub RedimPictureBoxPourImage(Pct_Box As PictureBox, Twips_Lg As Long, Twips_Ht As Long)
'Procdure de redimension
Dim Mem_AutoRedraw As Boolean
Dim Mem_ScaleMode As ScaleModeConstants
Dim Border_Ht As Integer, Border_Lg As Integer

On Error Resume Next

'Mmorisation de l'unit de mesure (vbPixel, vbTwips, ...)
Mem_ScaleMode = Pct_Box.ScaleMode
'Mmorisation de la mthode graphique
Mem_AutoRedraw = Pct_Box.AutoRedraw
Pct_Box.AutoRedraw = True
Pct_Box.ScaleMode = vbTwips 'Mesure en Twips - chelle

Border_Lg = Pct_Box.Width - Pct_Box.ScaleWidth
Border_Ht = Pct_Box.Height - Pct_Box.ScaleHeight
'L'image est place en Pct_Box.Left, Pct_Box.Top
Pct_Box.Move Pct_Box.Left, Pct_Box.Top, Twips_Lg + Border_Lg, Twips_Ht + Border_Ht

Pct_Box.ScaleMode = Mem_ScaleMode
''Pct_Box.Refresh 'Actualise l'image
Pct_Box.AutoRedraw = Mem_AutoRedraw
End Sub

Public Sub Position_InfoBulle(Obj_Declenche As Object, InfoBulle_Pct As PictureBox, Pointeur_X As Single, Pointeur_Y As Single)
'Ajustage personnalis TOP & LEFT info-bulle sur la Form
'suivant le positionnement de la souris sur l'Obj_Declenche

'L'Obj_Declenche est divis en 4 zones
Dim H_Centre As Long 'Milieu hauteur Obj_Declenche
Dim W_Centre As Long 'Milieu largeur Obj_Declenche

On Error Resume Next

'Ca va nous permettre de faire 4 zones sur l'Obj_Declenche
H_Centre = CLng(Fix(Obj_Declenche.Height / 2))
W_Centre = CLng(Fix(Obj_Declenche.Width / 2))

'Positionne l'info-bulle sur la Form
'Dtermine la position du bec de l'info-bulle, droite ou gauche, en haut ou en bas
'On divise la surface de l'objet dclencheur par 4, pour faire 4 zones de positionnements
'Gestion automatique quelque soit la position de l'objet dclencheur sur la Form
If Pointeur_X < (W_Centre + 1) Then '******Partie gauche******
  If Pointeur_Y < (H_Centre + 1) Then '******Partie haute (zone haute  gauche)******
    If ((Obj_Declenche.Left + Pointeur_X) + (HG_Ajust_X)) < 0 Then
      'Dpassement  gauche de la From
      InfoBulle_Pct.Left = 0 'position par dfaut
    Else 'Pas de depassement, c'est Ok
      If ((Obj_Declenche.Left + Pointeur_X + InfoBulle_Pct.Width) + (HG_Ajust_X)) > Form1.ScaleWidth Then
        'Dpassement  droite de la Form, remplace HG par HD
        InfoBulle_Pct.Left = ((Obj_Declenche.Left + Pointeur_X) + (HD_Ajust_X) - InfoBulle_Pct.Width)
      Else
        InfoBulle_Pct.Left = ((Obj_Declenche.Left + Pointeur_X) + (HG_Ajust_X))
      End If
    End If
    If ((Obj_Declenche.Top + Pointeur_Y) + (HG_Ajust_Y)) < InfoBulle_Pct.Height Then
      'Dpassement en haut de la From
      InfoBulle_Pct.Top = (Obj_Declenche.Top + Pointeur_Y + (BG_Ajust_Y))
      If ((Obj_Declenche.Left + Pointeur_X + InfoBulle_Pct.Width) + (HG_Ajust_X)) > Form1.ScaleWidth Then
        'Dpassement  droite de la Form, remplace HG par HD
        If Mem_PosBec <> "HD" Then
          Mem_PosBec = "HD" 'Position du bec en haut  droite
          'Appel procdure de positionnement texte, panneau et fermeture
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        If Mem_PosBec <> "HG" Then 'Mmoire de position du bec afin de limiter l'utilisation des ressources
          Mem_PosBec = "HG" 'Position du bec en haut  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    Else 'Pas de dpassement, c'est Ok
      InfoBulle_Pct.Top = (((Obj_Declenche.Top + Pointeur_Y) + (HG_Ajust_Y)) - InfoBulle_Pct.Height)
      If ((Obj_Declenche.Left + Pointeur_X + InfoBulle_Pct.Width) + (HG_Ajust_X)) > Form1.ScaleWidth Then
        'Dpassement  droite de la Form, remplace BG par BD
        If Mem_PosBec <> "BD" Then
          Mem_PosBec = "BD" 'Position du bec en bas  droite
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        If Mem_PosBec <> "BG" Then
          Mem_PosBec = "BG" 'Position du bec en bas  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    End If
  Else '*****Partie bas (zone bas  gauche)*****
    If ((Obj_Declenche.Left + Pointeur_X) + (BG_Ajust_X)) < 0 Then
      'Dpassement  gauche de la Form
      InfoBulle_Pct.Left = 0 'Position par dfaut
    Else 'Pas de dpassement, c'est Ok
      If ((Obj_Declenche.Left + Pointeur_X + InfoBulle_Pct.Width) + (BG_Ajust_X)) > Form1.ScaleWidth Then
        'Dpassement  droite de la Form, remplace BG par BD
        InfoBulle_Pct.Left = ((Obj_Declenche.Left + Pointeur_X) + (BD_Ajust_X) - InfoBulle_Pct.Width)
      Else
        InfoBulle_Pct.Left = ((Obj_Declenche.Left + Pointeur_X) + (BG_Ajust_X))
      End If
    End If
    If ((Obj_Declenche.Top + Pointeur_Y + InfoBulle_Pct.Height) + (BG_Ajust_Y)) > Form1.ScaleHeight Then
      'Dpassement bas de la Form
      InfoBulle_Pct.Top = (((Obj_Declenche.Top + Pointeur_Y) + (HG_Ajust_Y)) - InfoBulle_Pct.Height)
      If ((Obj_Declenche.Left + Pointeur_X + InfoBulle_Pct.Width) + (BG_Ajust_X)) > Form1.ScaleWidth Then
        'Dpassement droite de la Form, remplace BG par BD
        If Mem_PosBec <> "BD" Then
          Mem_PosBec = "BD" 'Position du bec en bas  droite
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        If Mem_PosBec <> "BG" Then
          Mem_PosBec = "BG" 'Position du bec en bas  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    Else 'Pas de dpassement, c'est Ok
      InfoBulle_Pct.Top = ((Obj_Declenche.Top + Pointeur_Y) + (BG_Ajust_Y))
      If ((Obj_Declenche.Left + Pointeur_X + InfoBulle_Pct.Width) + (BG_Ajust_X)) > Form1.ScaleWidth Then
        'Dpassement de la Form, remplace HG par HD
        If Mem_PosBec <> "HD" Then
          Mem_PosBec = "HD" 'Position du bec en haut  droite
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        If Mem_PosBec <> "HG" Then
          Mem_PosBec = "HG" 'Position du bec en haut  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    End If
  End If
Else '******Partie droite******
  If Pointeur_Y < (H_Centre + 1) Then '*****Partie haute (zone haute  droite)*****
    If ((Obj_Declenche.Left + Pointeur_X) + (HD_Ajust_X) - (InfoBulle_Pct.Width)) > Form1.ScaleWidth Then
      'Dpassement  droite de la Form
      InfoBulle_Pct.Left = Form1.ScaleWidth - InfoBulle_Pct.Width
    Else 'Pas de dpassement, c'est Ok
      If ((Obj_Declenche.Left + Pointeur_X) + (HD_Ajust_X) - (InfoBulle_Pct.Width)) < 0 Then
        'Dpassement gauche de la Form, remplace HD par HG
        InfoBulle_Pct.Left = ((Obj_Declenche.Left + Pointeur_X) + (HG_Ajust_X))
      Else
        InfoBulle_Pct.Left = ((Obj_Declenche.Left + Pointeur_X) + (HD_Ajust_X) - (InfoBulle_Pct.Width))
      End If
    End If
    If ((Obj_Declenche.Top + Pointeur_Y) + (HD_Ajust_Y)) < InfoBulle_Pct.Height Then
      'Dpassement haut de la Form
      If ((Obj_Declenche.Left + Pointeur_X) + (HD_Ajust_X) - (InfoBulle_Pct.Width)) < 0 Then
        'Dpassement gauche de la Form, remplace HD par HG
        InfoBulle_Pct.Top = ((Obj_Declenche.Top + Pointeur_Y) + (BG_Ajust_Y))
        If Mem_PosBec <> "HG" Then
          Mem_PosBec = "HG" 'Position du bec en haut  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        InfoBulle_Pct.Top = (Obj_Declenche.Top + Pointeur_Y + (BD_Ajust_Y))
        If Mem_PosBec <> "HD" Then
          Mem_PosBec = "HD" 'Position du bec en haut  droite
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    Else 'Pas de dpassement, c'est Ok
      InfoBulle_Pct.Top = (((Obj_Declenche.Top + Pointeur_Y) + (HD_Ajust_Y)) - InfoBulle_Pct.Height)
      If ((Obj_Declenche.Left + Pointeur_X) + (HD_Ajust_X) - (InfoBulle_Pct.Width)) < 0 Then
        'Dpassement gauche de la Form, remplacement BD par BG
        If Mem_PosBec <> "BG" Then
          Mem_PosBec = "BG" 'Position du bec en bas  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        If Mem_PosBec <> "BD" Then
          Mem_PosBec = "BD" 'Position du bec en bas  droite
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    End If
  Else '*****Partie bas (zone bas  droite)*****
    If ((Obj_Declenche.Left + Pointeur_X) + (BD_Ajust_X)) > Form1.ScaleWidth Then
      'Dpassement de la feuille  droite de la Form
      InfoBulle_Pct.Left = Form1.ScaleWidth - InfoBulle_Pct.Width
    Else 'Pas de dpassement, c'est Ok
      If (((Obj_Declenche.Left + Pointeur_X) + (BD_Ajust_X)) - InfoBulle_Pct.Width) < 0 Then
        'Dpassement  gauche de la form, remplacement BD par BG
        InfoBulle_Pct.Left = ((Obj_Declenche.Left + Pointeur_X) + (BG_Ajust_X))
      Else
        InfoBulle_Pct.Left = (((Obj_Declenche.Left + Pointeur_X) + (BD_Ajust_X)) - InfoBulle_Pct.Width)
      End If
    End If
    If ((Obj_Declenche.Top + Pointeur_Y + InfoBulle_Pct.Height) + (BD_Ajust_Y)) > Form1.ScaleHeight Then
      'Dpassement en bas de la Form
      If (((Obj_Declenche.Left + Pointeur_X) + (BD_Ajust_X)) - InfoBulle_Pct.Width) < 0 Then
        'Dpassement gauche de la Form, remplacement BD par BG
        If Mem_PosBec <> "BG" Then
          Mem_PosBec = "BG" 'Position du bec en bas  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        InfoBulle_Pct.Top = (((Obj_Declenche.Top + Pointeur_Y) + (HG_Ajust_Y)) - InfoBulle_Pct.Height)
        If Mem_PosBec <> "BD" Then
          Mem_PosBec = "BD" 'Position du bec en bas  droite
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    Else 'Pas de dpassement, c'est Ok
      If (((Obj_Declenche.Left + Pointeur_X) + (BD_Ajust_X)) - InfoBulle_Pct.Width) < 0 Then
        'Dpassement  gauche de la Form, remplace HD par HG
        InfoBulle_Pct.Top = ((Obj_Declenche.Top + Pointeur_Y) + (BG_Ajust_Y))
        If Mem_PosBec <> "HG" Then
          Mem_PosBec = "HG" 'Position du bec en haut  gauche
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      Else
        InfoBulle_Pct.Top = ((Obj_Declenche.Top + Pointeur_Y) + (BD_Ajust_Y))
        If Mem_PosBec <> "HD" Then
          Mem_PosBec = "HD" 'Position du bec en haut  droite
          Call Type_PositionBec_InfoBulle(InfoBulle_Pct)
        End If
      End If
    End If
  End If
End If
End Sub

Public Sub Type_PositionBec_InfoBulle(InfoBulle_PctBox As PictureBox)
'Procdure de slection du type et du bec de l'info-bulle
On Error Resume Next

InfoBulle_PctBox.Visible = False
Select Case Mem_InfobulleType 'Select type info-bulle
  Case 0 'Type 1
    'Positionnement du Bec gauche/droite haut/bas
    Select Case Mem_PosBec
      Case "BG" 'Position du bec en bas  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type1_BG.Picture
      Case "HG" 'Position du bec en haut  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type1_HG.Picture
      Case "BD" 'Position du bec en bas  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type1_BD.Picture
      Case "HD" 'Position du bec en haut  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type1_HD.Picture
      Case Else
    
    End Select
  Case 1 'Type 2
    'Bec gauche/droite haut/bas
    Select Case Mem_PosBec
      Case "BG" 'Position du bec en bas  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type2_BG.Picture
      Case "HG" 'Position du bec en haut  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type2_HG.Picture
      Case "BD" 'Position du bec en bas  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type2_BD.Picture
      Case "HD" 'Position du bec en haut  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type2_HD.Picture
      Case Else
    
    End Select
  Case 2 'Type 3
    'Bec gauche/droite haut/bas
    Select Case Mem_PosBec
      Case "BG" 'Position du bec en bas  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type3_BG.Picture
      Case "HG" 'Position du bec en haut  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type3_HG.Picture
      Case "BD" 'Position du bec en bas  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type3_BD.Picture
      Case "HD" 'Position du bec en haut  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type3_HD.Picture
      Case Else
    
    End Select
  Case 3 'Type 4
    'Bec gauche/droite haut/bas
    Select Case Mem_PosBec
      Case "BG" 'Position du bec en bas  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type4_BG.Picture
      Case "HG" 'Position du bec en haut  gauche
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type4_HG.Picture
      Case "BD" 'Position du bec en bas  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type4_BD.Picture
      Case "HD" 'Position du bec en haut  droite
        InfoBulle_PctBox.Picture = Form1.InfoBulle_Type4_HD.Picture
      Case Else
    
    End Select
  Case Else

End Select

'Appel la procdure qui va remplacer la couleur slectionn par des zones transparentes
Call Couleur_Invisible(InfoBulle_PctBox, TransColor_InfoBulle)
If Infobulle_ChangeColor = True Then 'Change une couleur de l'info-bulle
  If Infobulle_OldColor <> Infobulle_NewColor Then 'Check si traiter le changement de couleurs
    Call Remplace_Couleur(InfoBulle_PctBox, Infobulle_OldColor, Infobulle_NewColor)
  End If
End If
Call DimInfoBulle_PosObjetInside
'InfoBulle_PctBox.Refresh
InfoBulle_PctBox.Visible = True
End Sub

Private Sub DimInfoBulle_PosObjetInside()
'Procdure qui va dimensionner l'info-bulle et positionner tout les
'lments intrieur, (InfoBulle_Panneau, InfoBulle_Text et InfoBulle_Close)

'Positionnement des lments dans l'info-bulle avec les dcalages
'Le positionnement du panneau ou la case fermeture dpend du Top et Left de InfoBulle_Text
'InfoBulle_Text se positionne centr verticalement et horizontalement
'Le dcalage est un pourcentage de l'objet
'Rcupration du type de bec info-bulle
'Les variables de dcalages du texte fonctionnent avec les 4 type d'info-bulle

Dim DecalHorzTxt As Long, DecalVertTxt As Long

On Error Resume Next

Select Case Mem_PosBec
  Case "HG"
    DecalHorzTxt = DecalHorz_Txt_HG 'En haut  gauche en %
    DecalVertTxt = DecalVert_Txt_HG '  "  "    "  "
  Case "BG"
    DecalHorzTxt = DecalHorz_Txt_BG 'En bas  gauche en %
    DecalVertTxt = DecalVert_Txt_BG '  "  "    "  "
  Case "HD"
    DecalHorzTxt = DecalHorz_Txt_HD 'En haut  droite en %
    DecalVertTxt = DecalVert_Txt_HD '  "  "    "  "
  Case "BD"
    DecalHorzTxt = DecalHorz_Txt_BD 'En bas  droite en %
    DecalVertTxt = DecalVert_Txt_BD '  "  "    "  "
  Case Else

End Select

'R-actualise la rcupration des dimensions hauteur/largeur des lments
Ht_Txt = 0: Lg_Txt = 0
Ht_Txt = Form1.LabelEspion_Ht.Height
Lg_Txt = Form1.InfoBulle_Text.Width

Ht_Panneau = 0: Lg_Panneau = 0
If PanneauIndex > 0 And PanneauIndex < 6 Then 'Prend en compte le panneau
  Ht_Panneau = Form1.InfoBulle_Panneau(PanneauIndex - 1).Height
  Lg_Panneau = Form1.InfoBulle_Panneau(PanneauIndex - 1).Width
End If

Ht_Close = 0: Lg_Close = 0
If Affiche_Close = True Then 'Prend en compte la case fermeture
  Ht_Close = Form1.InfoBulle_Close.Height
  Lg_Close = Form1.InfoBulle_Close.Width
End If

'1 - Positionnement InfoBulle_Text
Form1.InfoBulle_Text.Top = Fix((Form1.InfoBulle_Picture.ScaleHeight - Ht_Txt) / 2) + (Ht_Txt * DecalVertTxt / 100)
Form1.InfoBulle_Text.Left = Fix((Form1.InfoBulle_Picture.ScaleWidth - Lg_Txt) / 2) + (Lg_Txt * DecalHorzTxt / 100)

'2 - Positionnement InfoBulle_Panneau
If PanneauIndex > 0 And PanneauIndex < 6 Then
  Form1.InfoBulle_Panneau(PanneauIndex - 1).Top = Form1.InfoBulle_Text.Top + (Ht_Panneau * DecalVert_Pan / 100)
  Form1.InfoBulle_Panneau(PanneauIndex - 1).Left = (Form1.InfoBulle_Text.Left - Lg_Panneau) + (Lg_Panneau * DecalHorz_Pan / 100)
End If

'3 - Positionnement InfoBulle_Panneau
Form1.InfoBulle_Close.Top = Form1.InfoBulle_Text.Top + (Ht_Close * DecalVert_Cls / 100)
Form1.InfoBulle_Close.Left = (Form1.InfoBulle_Text.Left + Form1.InfoBulle_Text.Width) + (Lg_Close * DecalHorz_Cls / 100)
End Sub

